# == Schema Information
#
# Table name: media_objs
#
#  id                :integer          not null, primary key
#  file_file_name    :string(255)
#  file_content_type :string(255)
#  file_file_size    :integer
#  file_updated_at   :datetime
#  type              :string(255)
#  creator_type      :string(255)
#  creator_id        :integer
#  created_at        :datetime         not null
#  updated_at        :datetime         not null
#
# Indexes
#
#  index_media_objs_on_creator_type_and_creator_id  (creator_type,creator_id)
#
module Whaleback
  module Media
    class Obj
      class Image < Obj
        has_attached_file :file, styles: {
          thumb: ["32x32#", :png],
          medium: '300x300>', 
          product: '600x600>'
        }
        validates_attachment_size :file, less_than: 5.megabytes
        validates_attachment_content_type :file, content_type: /image\/.*\Z/

        def default_mode
          :original
        end
      end
    end
  end
end
